import 'functions.dart';

class Effect<TArgs, TResult> {
  const Effect();
}

class OnExceptionEffect<TArgs, TResult> extends Effect<TArgs, TResult> {
  const OnExceptionEffect(this._onException);
  final ExceptionEffectFun<TArgs> _onException;

  Future<void> onException(TArgs args, dynamic e, [StackTrace t]) {
    return _onException(args, e, t);
  }
}

class OnDataEffect<TArgs, TResult> extends Effect<TArgs, TResult> {
  const OnDataEffect(this._onData);
  final EffectFun<TArgs, TResult> _onData;

  Future<void> onData(TArgs args, TResult res) {
    return _onData(args, res);
  }
}

class AsyncEffect<TArgs, TResult> extends Effect<TArgs, TResult>
    implements OnDataEffect<TArgs, TResult>, OnExceptionEffect<TArgs, TResult> {
  const AsyncEffect(this._onData, this._onException);
  final EffectFun<TArgs, TResult> _onData;
  final ExceptionEffectFun<TArgs> _onException;

  Future<void> onData(TArgs args, TResult res) {
    return _onData(args, res);
  }

  Future<void> onException(TArgs args, dynamic e, [StackTrace t]) {
    return _onException(args, e, t);
  }
}
